---
title: DebugService
description: DebugService defines unary RPCs helpful for debugging.
source_url:
  html: https://thru.org/docs/api-ref/grpc/services/debug-service/
  md: https://thru.org/docs/api-ref/grpc/services/debug-service.md
---

# DebugService

DebugService defines unary RPCs helpful for debugging.

**Package:** `thru.services.v1`

## RPCs

### `DebugReExecute`

DebugReExecute executes a transaction in simulated environment.

- **Request:** [`DebugReExecuteRequest`](https://thru.org/docs/api-ref/grpc/messages/thru/services/v1/debug-re-execute-request.md)
- **Response:** [`DebugReExecuteResponse`](https://thru.org/docs/api-ref/grpc/messages/thru/services/v1/debug-re-execute-response.md)

**Try it live:** gRPC-Web `POST https://grpc-web.alphanet.thruput.org` (`thru.services.v1.DebugService/DebugReExecute`) with request body:

```json
{
"signature": { "value": "2Jqjbuct1yuDSIsJJlol3NG1MvvBtsiETcSXopHFOPC7QaD0DnqBbUceMnCxd8ItFrQFOK1iLXDFl0w2GYZlDw==" },
"includeStateBefore": true,
"includeStateAfter": true
}
```
